﻿Imports System.IO
Imports Steema.TeeChart

Public Class Form1
    'Private WithEvents VolumeSeries1 As Steema.TeeChart.Styles.Volume
    Private WithEvents CandleSeries1 As Steema.TeeChart.Styles.Candle
    Private WithEvents BottomAxis As Steema.TeeChart.Axis
    Private GreenAxis As Steema.TeeChart.Axis
    Private BlueAxis As Steema.TeeChart.Axis

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click

        TChart1.Series.Clear()

        TChart1.Page.MaxPointsPerPage = 150

        TChart1.Header.Visible = False
        TChart1.AutoRepaint = False
        TChart1.Aspect.View3D = False
        TChart1.Legend.Visible = False
        TChart1.Axes.Left.Visible = True
        TChart1.Axes.Right.Visible = True
        TChart1.Axes.Top.Visible = False
        TChart1.Axes.Bottom.Visible = True
        BottomAxis = TChart1.Axes.Bottom

        TChart1.Panel.BorderRound = 0
        TChart1.Panel.Transparency = 100
        TChart1.Panel.Transparent = True
        TChart1.Walls.Back.ImageMode = Steema.TeeChart.Drawing.ImageMode.Normal
        TChart1.Panning.Allow = ScrollModes.Both
        TChart1.Panning.MouseButton = Windows.Forms.MouseButtons.Right
        TChart1.Panel.MarginLeft = 3
        TChart1.Panel.MarginRight = 7
        'SelectorTool = New Steema.TeeChart.Tools.Selector
        'TChart1.Tools.Add(SelectorTool)
        GreenAxis = New Steema.TeeChart.Axis(TChart1.Chart)
        GreenAxis.OtherSide = True
        GreenAxis.AxisPen.Color = Color.Green
        GreenAxis.StartPosition = 0
        GreenAxis.EndPosition = 73
        GreenAxis.Automatic = True

        Me.TChart1.Axes.Custom.Add(GreenAxis)

        'BlueAxis = New Steema.TeeChart.Axis(TChart1.Chart)
        'BlueAxis.OtherSide = True
        'BlueAxis.AxisPen.Color = Color.Blue
        'BlueAxis.StartPosition = 75
        'BlueAxis.EndPosition = 100
        'BlueAxis.Automatic = True
        'Me.TChart1.Axes.Custom.Add(BlueAxis)

        Me.CandleSeries1 = New Steema.TeeChart.Styles.Candle
        CandleSeries1.VertAxis = Steema.TeeChart.Styles.VerticalAxis.Both
        CandleSeries1.TreatNulls = Styles.TreatNullsStyle.Ignore
        CandleSeries1.CandleWidth = 4
        CandleSeries1.HighLowPen.Width = 2
        CandleSeries1.LinePen.Width = 1
        CandleSeries1.LinePen.EndCap = Drawing2D.LineCap.Square
        CandleSeries1.Style = Styles.CandleStyles.CandleBar
        CandleSeries1.UpCloseColor = Color.Green
        CandleSeries1.DownCloseColor = Color.Red
        CandleSeries1.Pen.Width = 2



        CandleSeries1.VertAxis = Styles.VerticalAxis.Right
        CandleSeries1.CustomVertAxis = GreenAxis
        CandleSeries1.Pen.EndCap = Drawing2D.LineCap.Flat

        GreenAxis.Automatic = True

        TChart1.Series.Add(CandleSeries1)


        Dim NewAxis As Steema.TeeChart.Axis = New Steema.TeeChart.Axis(TChart1.Chart)
        NewAxis.OtherSide = True
        NewAxis.AxisPen.Color = Color.Green
        NewAxis.StartPosition = 74 '+ 2
        NewAxis.EndPosition = 100
        NewAxis.Automatic = True
        NewAxis.Visible = True
        Dim CCITag As String = "CCI-"
        NewAxis.Tag = CCITag
        Me.TChart1.Axes.Custom.Add(NewAxis)

        Dim line1 As New Steema.TeeChart.Styles.Line(TChart1.Chart)
        Dim CCI1 As New Steema.TeeChart.Functions.CCIFunction

        line1.Function = CCI1
        CCI1.Tag = CCITag
        Dim eCnt As Integer = 0
        line1.DataSource = CandleSeries1

        TChart1.Walls.Back.Gradient.Visible = False
        TChart1.Walls.Back.Color = Color.White

        Dim dl As New OpenFileDialog
        If Directory.Exists("C:\logs") Then
            dl.InitialDirectory = "c:\log"
        Else
            dl.InitialDirectory = "c:\"
        End If
        dl.FileName = "chart1b.txt"
        dl.Filter = "TextFiles (*.txt)|*.txt"
        dl.FilterIndex = 0

        Dim dr As DialogResult = dl.ShowDialog
        If dr = Windows.Forms.DialogResult.OK Then
            Dim fname As String = dl.FileName
            If File.Exists(fname) Then
                Dim fNum As Integer = FreeFile()
                FileOpen(fNum, fname, OpenMode.Input)
                Dim x As Integer = -1

                While (Not EOF(fNum))
                    x = x + 1
                    Dim s As String = LineInput(fNum)
                    If s.Length > 0 Then
                        Dim ss() As String = s.Split(",")
                        Dim Open, High, Low, Close
                        Open = Convert.ToDouble(ss(1))
                        High = Convert.ToDouble(ss(2))
                        Low = Convert.ToDouble(ss(3))
                        Close = Convert.ToDouble(ss(4))
                        'Volume = Convert.ToDouble(ss(1))
                        If Low <> 0 And High <> 0 And Close <> 0 Then
                            CandleSeries1.Add(x, Open, High, Low, Close)
                            CandleSeries1.Labels(x) = ss(0)
                        End If
                    End If
                End While


                Dim cst As Double = CCI1.Constant
                'line1.YValues.DataMember = "Close"
                line1.Function.Period = 20
                line1.Function.PeriodAlign = Functions.PeriodAligns.Last
                line1.Function.PeriodStyle = Functions.PeriodStyles.NumPoints
                Dim c As Color = Color.Blue
                line1.Color = c
                line1.CustomVertAxis = NewAxis
                Dim pWidth As Integer = 1
                line1.LinePen.Width = pWidth
                line1.TreatNulls = Steema.TeeChart.Styles.TreatNullsStyle.DoNotPaint

                line1.CheckDataSource()
                line1.Tag = CCITag


                BottomAxis.SetMinMax(x - 150, x)

                TChart1.Invalidate()

            End If
        End If



    End Sub

    Private Sub TChart1_AllowScroll(ByVal a As Steema.TeeChart.Axis, ByVal e As Steema.TeeChart.TChart.AllowScrollEventArgs) Handles TChart1.AllowScroll
        TChart1.Invalidate()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        TChart1.ShowEditor()
    End Sub
End Class
